package Arithmetic;

import java.util.*;

/**
 * 
 *
 * Class for evaluating arithmetic expressions
 * (uses infix to postfix conversion)
 * 
 * v0.1 contains: +,-,*,/,sin,cos,tan,ln
 *
 * @author rapasoft, rapasoft@zmail.sk
 * @see http://rapasoft.nazory.cz/
 * 
 */
public class ArithmeticExpression {
private String expression;	
	
	/**
	 * @return String representation of arithmetic expression
	 */
	public String toString(){
		return expression;
	}

	/**
	 * Empty constructor
	 */
	public ArithmeticExpression(){
		expression = new String();
	}
	
	/**
	 * Creates an instance of ArithmeticExpression from String input.
	 * @param exp - String input of expression in infix notation.
	 */
	public ArithmeticExpression(String exp){
		expression = exp;
	}
	
	/**
	 * 
	 * @return Postfix (Reverse Polish Notation) of Infix expression
	 */
	public String toPostfix(){
		return InfixToPostfix.convertToPostfix(expression);
	}
	
	/**
	 * Evaluates the expression in Postfix (RPN) notation
	 * @return double value of expression
	 */
	public double evaluate(){
		expression = InfixToPostfix.convertToPostfix(expression);
		StringTokenizer tok = new StringTokenizer(expression," [,]",false);
		Stack<String> stack = new Stack<String>();
		while(tok.hasMoreTokens()){
			String next = tok.nextToken();
			try{
				Double.parseDouble(next);
				stack.push(next);
			}
			catch(Exception e){
				if(stack.size()<2){
					
				}
				else{
					if(next.equals("+"))
						stack.push(String.valueOf(Double.parseDouble(stack.pop())+Double.parseDouble(stack.pop())));
					else if(next.equals("-")){
						double help = Double.parseDouble(stack.pop());
						stack.push(String.valueOf(Double.parseDouble(stack.pop())-help));
					}
					else if(next.equals("*"))
						stack.push(String.valueOf(Double.parseDouble(stack.pop())*Double.parseDouble(stack.pop())));
					else if(next.equals("/")){
						double help = Double.parseDouble(stack.pop());
						stack.push(String.valueOf(Double.parseDouble(stack.pop())/help));
					}
				}
			}
		}
		if(stack.size()==1){
			return Double.parseDouble(stack.pop());
		}
		else
			System.out.println("error");
		return 0;
	}
}
