package Arithmetic;

import java.util.*;

/**
 * Class for converting expression from Infix to Postfix
 */
public class InfixToPostfix {
	
	/**
	 * @return String output of Infix expression in RPN.
	 */
	public static String convertToPostfix(String entry) {
		String result = "";
		Stack<String> vysledok = new Stack<String>();
		Stack<String> operatory = new Stack<String>();
		ArrayList<Character> cisla = new ArrayList<Character>();
		for(int i=0;i<10;i++){
			cisla.add(String.valueOf(i).charAt(0));
		}
		// if there is unary -
		boolean isNotUM = false;
		while(!isNotUM){
			isNotUM = true;
			for(int i=0;i<entry.length();i++){
				if(i>0){
					if(entry.charAt(i)=='-'){
						if(entry.charAt(i-1)=='('){
							String help = "";
							int s = i;
							i++;
							while(cisla.contains(entry.charAt(i))){
								help += entry.charAt(i);
								i++;
							}
							entry = entry.substring(0, s)+"0-"+help+""+entry.substring(i,entry.length());
							i = s;
							isNotUM = false;
						}
					}
				}
				else{
					if(entry.charAt(i)=='-'){
						String help = "";
						i++;
						while(cisla.contains(entry.charAt(i))){
							help += entry.charAt(i);
							i++;
						}
						entry = "(0-"+help+")"+entry.substring(i,entry.length());
						isNotUM = false;
					}
				}
			}
		}
		// if there is sin, cos, tg, ln
		boolean isNotG = false;
		while (!isNotG) {
			isNotG = true;
			for (int i = 0; i < entry.length() - 2; i++) {
				if (entry.charAt(i) == 's') { // sinus
					int s = i;
					i = i + 4;// jump to (
					String help = "";
					int pocetZatvoriek = 1;
					while (pocetZatvoriek>0) {
						if(entry.charAt(i) == '(')
							pocetZatvoriek++;
						if(entry.charAt(i) == ')')
							pocetZatvoriek--;
						help += entry.charAt(i);
						i++;
					}
					help = help.substring(0,help.length()-1);
					ArithmeticExpression vyraz = new ArithmeticExpression(help);
					Double sinus = Math.sin(Math.toRadians(vyraz.evaluate()));
					String orezTo = String.valueOf(sinus);
					if(orezTo.length()>5){
						orezTo = orezTo.substring(0, orezTo.length()-5);
					}
					sinus = Double.parseDouble(orezTo);
					if(sinus<0)
						help = "(0"+sinus+")";
					else
						help = String.valueOf(sinus);
					entry = entry.substring(0, s)
							+ help
							+ entry.substring(i, entry.length());
					i = s;
					isNotG = false;
				}
				else if (entry.charAt(i) == 't') { // tan
					int s = i;
					i = i + 4;// jump to (
					String help = "";
					int pocetZatvoriek = 1;
					while (pocetZatvoriek>0) {
						if(entry.charAt(i) == '(')
							pocetZatvoriek++;
						if(entry.charAt(i) == ')')
							pocetZatvoriek--;
						help += entry.charAt(i);
						i++;
					}
					help = help.substring(0,help.length()-1);
					ArithmeticExpression vyraz = new ArithmeticExpression(help);
					Double tangens = Math.tan(Math.toRadians(vyraz.evaluate()));
					if(tangens<0)
						help = "(0"+tangens+")";
					else
						help = String.valueOf(tangens);
					entry = entry.substring(0, s)
							+ help
							+ entry.substring(i, entry.length());
					i = s;
					isNotG = false;
				}
				else if (entry.charAt(i) == 'c') { // cosinus
					int s = i;
					i = i + 4;// jump to (
					String help = "";
					int pocetZatvoriek = 1;
					while (pocetZatvoriek>0) {
						if(entry.charAt(i) == '(')
							pocetZatvoriek++;
						if(entry.charAt(i) == ')')
							pocetZatvoriek--;
						help += entry.charAt(i);
						i++;
					}
					help = help.substring(0,help.length()-1);
					ArithmeticExpression vyraz = new ArithmeticExpression(help);
					Double cosinus = Math.cos(Math.toRadians(vyraz.evaluate()));
					if(cosinus<0)
						help = "(0"+cosinus+")";
					else
						help = String.valueOf(cosinus);
					entry = entry.substring(0, s)
							+ help
							+ entry.substring(i, entry.length());
					i = s;
					isNotG = false;
				}
				else if (entry.charAt(i) == 'l') { // ln
					int s = i;
					i = i + 3;// jump to (
					String help = "";
					int pocetZatvoriek = 1;
					while (pocetZatvoriek>0) {
						if(entry.charAt(i) == '(')
							pocetZatvoriek++;
						if(entry.charAt(i) == ')')
							pocetZatvoriek--;
						help += entry.charAt(i);
						i++;
					}
					help = help.substring(0,help.length()-1);
					ArithmeticExpression vyraz = new ArithmeticExpression(help);
					Double ln = Math.log(vyraz.evaluate());
					if(ln<0)
						help = "(0"+ln+")";
					else
						help = String.valueOf(ln);
					entry = entry.substring(0, s)
							+ help
							+ entry.substring(i, entry.length());
					i = s;
					isNotG = false;
				}
				else
					i=i++;
			}
		}
		StringTokenizer tok = new StringTokenizer(entry, "+-*/()", true);
		while (tok.hasMoreTokens()) {
			String dalsi = tok.nextToken();

			try {
				Double.parseDouble(dalsi);
				vysledok.add(dalsi);
			} catch (Exception e) {
				if (operatory.isEmpty()) {
					operatory.push(dalsi);
				} else {
					if (!operatory.isEmpty() && !dalsi.equals("(")
							&& !dalsi.equals(")")) {
						while (!operatory.empty()
								&& !(operatory.peek()).equals("(")
								&& prec(dalsi) <= prec(operatory.peek())) {
							vysledok.push(operatory.pop());
						}
						operatory.push(dalsi);
					} else if (dalsi.equals("("))
						operatory.push(dalsi);
					else if (dalsi.equals(")")) {
						do {
							vysledok.add(operatory.pop());
							if (operatory.peek().equals("("))
								break;
						} while (0 == 0);
						operatory.pop();
					}
				}
			}
		}
		while (!operatory.isEmpty())
			vysledok.add(operatory.pop());

		result = vysledok.toString();
		return result;
	}
	
	/**
	 * Private method for making decision what operand has
	 * more important precedence
	 * @param o1 - operand
	 * @return int value 0 or 1.
	 */
	private static int prec(String o1) {
		if (o1.equals("+"))
			return 0;
		if (o1.equals("-"))
			return 0;
		if (o1.equals("*"))
			return 1;
		if (o1.equals("/"))
			return 1;
		else
			return 0;
	}
}
